
/*------------------------------------------------------------------------
    File        : GetOOF.p
    Purpose     : Get the "Out of facility" message from exchange
                  for any account

    Syntax      :

    Description : 

    Author(s)   : 
    Created     : Wed May 20 10:24:55 EDT 2015
    Notes       :
  ----------------------------------------------------------------------*/

USING System.Net.*.
USING System.Xml.*.

DEFINE VARIABLE Client         AS WebClient.
DEFINE VARIABLE requestXML     AS CHARACTER.
DEFINE VARIABLE xDoc           AS XmlDocument.
DEFINE VARIABLE nsManager      AS XmlNamespaceManager.
DEFINE VARIABLE secretpassword AS CHARACTER.

SecretPassword = Microsoft.Win32.Registry:GetValue(
  "HKEY_CURRENT_USER\Software\PugChallenge",
  "SecretPassword","").

RequestXML = 
  '<soap:Envelope xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" ' + 
  'xmlns:xsd="http://www.w3.org/2001/XMLSchema" ' +
  'xmlns:soap="http://schemas.xmlsoap.org/soap/envelope/" ' +
  'xmlns:t="http://schemas.microsoft.com/exchange/services/2006/types"><soap:Header> ' +
  '<t:RequestServerVersion Version="Exchange2013"/></soap:Header><soap:Body>' +
  '<GetMailTips xmlns="http://schemas.microsoft.com/exchange/services/2006/messages">' +
  '<SendingAs>' +
  '<t:EmailAddress>tom.bergman@WoltersKluwer.com</t:EmailAddress>' +
  '<t:RoutingType>SMTP</t:RoutingType></SendingAs>' +
  '<Recipients>' +
  '<t:Mailbox>' +
  '<t:EmailAddress>Paul.Anderson@WoltersKluwer.com</t:EmailAddress>' +
  '</t:Mailbox>' + 
  '<t:Mailbox>' +
  '<t:EmailAddress>Tricia.Lewis@WoltersKluwer.com</t:EmailAddress>' +
  '</t:Mailbox>' + 
  '</Recipients> ' +
  '<MailTipsRequested>All</MailTipsRequested></GetMailTips>' +
  '</soap:Body></soap:Envelope>' .

Client = NEW WebClient().

Client:Headers:Add("Content-Type", "text/xml;charset=UTF-8").
/* This is not strictly needed, this URL could be the first
   parameter of the UploadString method */
Client:BaseAddress = "https://outlook.office365.com/EWS/Exchange.asmx".
Client:Credentials = NEW NetworkCredential("tom.bergman@wolterskluwer.com", SecretPassword).
/* We could use any of the Progress xml capabilities, but since
   this is a .Net demo .... */
xDoc = NEW XmlDocument().

/* UploadString lets me do a POST. It's the default but shown for clarity.
   Leaving out the second parameter would behave the same. */
xDoc:LoadXml(Client:UploadString("","POST",requestXML)).

nsManager = NEW XmlNamespaceManager(xDoc:NameTable).
nsManager:AddNamespace("t", "http://schemas.microsoft.com/exchange/services/2006/types").

MESSAGE xdoc:SelectSingleNode("//t:Message", NSManager):InnerText
  VIEW-AS ALERT-BOX.
xDoc:Save("c:\temp\mailtips.xml").
